﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.ReplacementTokens
{
  public class MonthReplacementToken : FormatStringReplacmentTokenBase
  {

    #region Private Fields

    private const string token = "$month$";
    private const string name = "MonthReplacementToken";
    private const string description = "The MontReplacementToken provides for the current month.";

    #endregion

    #region Constructors

    public MonthReplacementToken(string formatString)
    {
      FormatString = formatString;
    }

    public MonthReplacementToken()
    {

    }

    #endregion

    #region Public Methods

    public override string GetName()
    {
      return name;
    }

    public override string GetDescription()
    {
      return description;
    }

    public override string GetToken()
    {
      return token;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        string monthString = string.Format(FormatString, DateTime.Now.Month);
        tokenizedString = tokenizedString.Replace(Token, monthString);
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion

  }
}
