﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System.Security.Principal;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class CurrentUserReplacementToken : ReplacementTokenBase
  {

    #region Private Fields

    private const string TokenText = "$currentuser$";
    private const string TokenTextName = "Current Window User Replacement Token";
    private const string TokenTextDescription = "Currently logged on user name replacement token.";

    #endregion

    #region Public Methods

    public override string GetName()
    {
      return TokenTextName;
    }

    public override string GetDescription()
    {
      return TokenTextDescription;
    }

    public override string GetToken()
    {
      return TokenText;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(GetToken()))
      {
        WindowsIdentity id = WindowsIdentity.GetCurrent();
        if (id != null)
        {
          var index = id.Name.IndexOf(@"\");
          var userName = id.Name.Substring(index + 1);
          tokenizedString = tokenizedString.Replace(GetToken(), userName);
        }
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion

  }
}
