﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class HourReplacementToken: FormatStringReplacmentTokenBase
  {

    #region Private Fields

    private const string TokenText = "$hour$";
    private const string TokenName = "Hour Replacement Token";
    private const string TokenDescription = "The Hour Replacement Token provides the current hour.";

    #endregion

    #region Constructors

    public HourReplacementToken(string formatString)
    {
      FormatString = formatString;
    }

  	#endregion

    #region Public Methods

    public override string GetName()
    {
      return TokenName;
    }

    public override string GetDescription()
    {
      return TokenDescription;
    }

    public override string GetToken()
    {
      return TokenText;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        string hourString = string.Format(FormatString, DateTime.Now.Hour);
        tokenizedString = tokenizedString.Replace(Token, hourString);
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion
  }
}
