﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class MillisecondReplacementToken: FormatStringReplacmentTokenBase
  {

    #region Private Fields

    private const string TokenText = "$millisecond$";
    private const string TokenName = "Milisecond Replacement Token";
    private const string TokenDescription = "The Milisecond Replacement Token provides for the current milisecond.";

    #endregion

    #region Constructors

    public MillisecondReplacementToken(string formatString)
    {
      FormatString = formatString;
    }

    #endregion

    #region Public Methods

    public override string GetName()
    {
      return TokenName;
    }

    public override string GetDescription()
    {
      return TokenDescription;
    }

    public override string GetToken()
    {
      return TokenText;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        string millisecondString = string.Format(FormatString, DateTime.Now.Millisecond);
        tokenizedString = tokenizedString.Replace(Token, millisecondString);
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion

  }
}
