﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;

namespace codejockey.BingPaper.Configuration
{
  public class BingPaperConfigSection: ConfigurationSection
  {
     public static readonly string SectionName = "bingPaper";

    /// <summary>
    /// Retrieves the instance of the configuration section.
    /// </summary>
    /// <returns>An instance of the BingConfigSection configuration section.</returns>
    public static BingPaperConfigSection GetInstance()
    {
      BingPaperConfigSection section = ConfigurationManager.GetSection(SectionName) as BingPaperConfigSection;

      if (section == null)
        throw new Exception(string.Format("Missing config section: {0}", SectionName));

      return section;
    }

    [ConfigurationProperty("settings")]
    public BingPaperConfigElement Settings
    {
      get { return (BingPaperConfigElement)base["settings"]; }
      set { base["settings"] = value; }
    }
  }
}
