﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;

using Microsoft.VisualStudio.TestTools.UnitTesting;

using codejockey.BingPaper.Utils;


namespace BingPaperUnitTests
{
  /// <summary>
  /// Summary description for UnitTest1
  /// </summary>
  [TestClass]
  public class BingUtilsTests
  {
    private const string baseURL = "http://www.bing.com";
    private const string defaultRssURL = baseURL + "/HPImageArchive.aspx?format=xml&idx=0&n=1&cc=en-us";

    public BingUtilsTests()
    {
      //
      // TODO: Add constructor logic here
      //
    }

    private TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get
      {
        return testContextInstance;
      }
      set
      {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    //
    // You can use the following additional attributes as you write your tests:
    //
    // Use ClassInitialize to run code before running the first test in the class
    // [ClassInitialize()]
    // public static void MyClassInitialize(TestContext testContext) { }
    //
    // Use ClassCleanup to run code after all tests in a class have run
    // [ClassCleanup()]
    // public static void MyClassCleanup() { }
    //
    // Use TestInitialize to run code before running each test 
    // [TestInitialize()]
    // public void MyTestInitialize() { }
    //
    // Use TestCleanup to run code after each test has run
    // [TestCleanup()]
    // public void MyTestCleanup() { }
    //
    #endregion

    [TestMethod]
    public void GetBingImageName()
    {
      BingImageParams bingParams = new BingImageParams();
      bingParams.Uri = new Uri(defaultRssURL);

      BingImage bingImage = BingUtils.GetBingImage(bingParams);
            
      Assert.IsFalse(string.IsNullOrEmpty(bingImage.ImageName));
      Assert.IsFalse(string.IsNullOrEmpty(bingImage.ImageURL.ToString()));
    }

    [TestMethod]
    public void GetBingImage()
    {
      BingImageParams bingParams = new BingImageParams();
      bingParams.Uri = new Uri(defaultRssURL);

      BingImage bingImage = BingUtils.GetBingImage(bingParams);

      Assert.IsFalse(bingImage.CurrentImage == null);
    }

    [TestMethod]
    public void GetCountryCode()
    {
      string expected = "us";
      string actual = BingUtils.CurrentCountryCode;

      Assert.AreEqual(expected, actual);
    }

    [TestMethod]
    public void GetMessagesTest()
    {
      var image = BingUtils.GetBingImage(BingUtils.CountryCodes[BingUtils.CountryCodes.DefaultCountryCodeKey]);
      Assert.IsTrue(image.Messsages.Count > 0, "No messages were returned, however, at least one was expected.");
    }

    [TestMethod]
    public void GetCopyright()
    {
      var image = BingUtils.GetBingImage(BingUtils.CountryCodes[BingUtils.CountryCodes.DefaultCountryCodeKey]);
      Assert.IsFalse(string.IsNullOrEmpty(image.Copyright), "A copyright notice was not returned, however one was expected.");
    }

    [TestMethod]
    public void GetHotSpots()
    {
      var image = BingUtils.GetBingImage(BingUtils.CountryCodes[BingUtils.CountryCodes.DefaultCountryCodeKey]);
      Assert.IsTrue(image.HotSpots.Count > 0, "No HotSpots were returned, however, at least one was expected.");
    }
  }
}
