﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;

using codejockey.Shared.Text;

using codejockey.BingPaper.Utils;
using codejockey.BingPaper.Utils.ReplacementTokens;

using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BingUtilsUnitTests.cs
{
  /// <summary>
  /// Summary description for TokenTests
  /// </summary>
  [TestClass]
  public class TokenTests
  {
    public TokenTests()
    {
      //
      // TODO: Add constructor logic here
      //
    }

    private TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get
      {
        return testContextInstance;
      }
      set
      {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    //
    // You can use the following additional attributes as you write your tests:
    //
    // Use ClassInitialize to run code before running the first test in the class
    // [ClassInitialize()]
    // public static void MyClassInitialize(TestContext testContext) { }
    //
    // Use ClassCleanup to run code after all tests in a class have run
    // [ClassCleanup()]
    // public static void MyClassCleanup() { }
    //
    // Use TestInitialize to run code before running each test 
    // [TestInitialize()]
    // public void MyTestInitialize() { }
    //
    // Use TestCleanup to run code after each test has run
    // [TestCleanup()]
    // public void MyTestCleanup() { }
    //
    #endregion

    [TestInitialize]
    public void InitTest()
    {
      if (TokenManager.Tokens.Count == 0)
        TokenManager.LoadTokens();
    }
    
    [TestMethod]
    public void TestCurrentUserToken()
    {
      string expected = Environment.UserName;
      string actual = TokenManager.Parse("$currentuser$");

      Assert.AreEqual(expected, actual);
    }

    [TestMethod]
    public void TestCurrentDomainToken()
    {
      string expected = Environment.UserDomainName;
      string actual = TokenManager.Parse("$currentdomain$");

      Assert.AreEqual(expected, actual);
    }

    [TestMethod]
    public void TestCurrentYearToken()
    {
      var expected = DateTime.Now.ToString("yyyy");
      var actual = TokenManager.Parse("$year$");

      Assert.AreEqual(expected, actual);
    }

    [TestMethod]
    public void TestCurrentDayToken()
    {
      var expected = DateTime.Now.ToString("dd");
      var actual = TokenManager.Parse("$day$");

      Assert.AreEqual(expected, actual);
    }

    [TestMethod]
    public void TestCurrentMonthToken()
    {
      var expected = DateTime.Now.ToString("MM");
      var actual = TokenManager.Parse("$month$");

      Assert.AreEqual(expected, actual);
    }
  }
}
