﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;

using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace codejockey.BingPaper.Configuration
{
  public class BingPaperArchiveConfigElement : ConfigurationElement
  {
    /// <summary>
    /// FileName dictates what the file name should be saved as.  Note that this value is processed for
    /// replacement tokens.
    /// </summary>
    [ConfigurationProperty("fileName", IsRequired = true)]
    public string FileName
    {
      get { return (string)base["fileName"]; }
      set { base["fileName"] = value; }
    }

    /// <summary>
    /// FilePath contains the location of where the Bing image should be saved too.  Note that this value is
    /// processed for replacement tokens.
    /// </summary>
    [ConfigurationProperty("filePath", IsRequired = true)]
    public string FilePath
    {
      get { return (string)base["filePath"]; }
      set { base["filePath"] = value; }
    }

    /// <summary>
    /// ArchiveImage determines if the image is archived or deleted after the wall paper is set.
    /// </summary>
    [ConfigurationProperty("archiveImage", DefaultValue = true, IsRequired = false)]
    public bool ArchiveImage
    {
      get { return (bool)base["archiveImage"]; }
      set { base["archiveImage"] = value; }
    }
  }
}
