﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;

namespace codejockey.BingPaper.Configuration
{
  /// <summary>
  /// BingPaperWallPaperConfigElement is a physicial representation of a wall paper configuration element.
  /// </summary>
  public class BingPaperWallPaperConfigElement : ConfigurationElement
  {
    /// <summary>
    /// SetWallPaper determines if the wall paper background is set to today's Bing Image..
    /// </summary>
    /// <value><c>true</c> if [set wall paper]; otherwise, <c>false</c>.</value>
    [ConfigurationProperty("setWallPaper", IsRequired = true)]
    public bool SetWallPaper
    {
      get { return (bool)base["setWallPaper"]; }
      set { base["setWallPaper"] = value; }
    }

    /// <summary>
    /// Gets or sets the wall paper style.
    /// </summary>
    /// <example>Stretched, Tiled, Centered</example>
    /// <value>The wall paper style.</value>
    [ConfigurationProperty("wallPaperStyle", IsRequired = true)]
    public string WallPaperStyle
    {
      get { return (string)base["wallPaperStyle"]; }
      set { base["wallPaperStyle"] = value; }
    }
  }
}
