﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.ReplacementTokens
{
  public class DayReplacementToken : FormatStringReplacmentTokenBase
  {

    #region Private Fields

    private const string token = "$day$";
    private const string name = "DayReplacementToken";
    private const string description = "The DayReplacementToken provides for the current day.";

    #endregion

    #region Constructors

    public DayReplacementToken(string formatString)
    {
      FormatString = formatString;
    }

    public DayReplacementToken()
    {

    }

    #endregion

    #region Public Methods

    public override string GetToken()
    {
      return token;
    }
    
    public override string GetDescription()
    {
      return description;
    }
    
    public override string GetName()
    {
      return name;
    }
    
    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        string dayString = string.Format(FormatString, DateTime.Now.Day);
        tokenizedString = tokenizedString.Replace(Token, dayString);
        Processed = true;
      }
      
      return tokenizedString;
    }

    #endregion

  }
}
