﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace codejockey.BingPaper.Utils
{
  public class BingImageParams
  {
    #region Private Constants

    private const string baseURL = "http://www.bing.com";
    private const string defaultRssURL = baseURL + "/HPImageArchive.aspx?format=xml&idx=0&n=1&cc=en-us";
    private const string RssURLWithCountryCodeParm = baseURL + "/HPImageArchive.aspx?format=xml&idx=0&n=1&cc={0}";
    private const string RssURLWithCountryCodeAndIndexParams = baseURL + "/HPImageArchive.aspx?format=xml&idx={0}&n=1&cc={1}";

    #endregion

    private Uri uri;
    private string countryCode;
    private string path;
    private string fileName;
    private int dayIndex = 0;

    public bool Validate()
    {
      var result = true;

      return result;
    }

    public Uri Uri
    {
      get
      {
        if (uri == null)
        {
          if (!string.IsNullOrEmpty(CountryCode))
            uri = new Uri(string.Format(RssURLWithCountryCodeAndIndexParams, dayIndex, countryCode));
          else
            uri = new Uri(string.Format(RssURLWithCountryCodeAndIndexParams, dayIndex, BingUtils.CurrentCountryCode));
        }

        return uri;
      }

      set
      {
        uri = value;
      }
    }

    public int DayIndex
    {
      get
      {
        return dayIndex;
      }
      set
      {
        if (value > 7 || value < 0)
          throw new ApplicationException("The DayIndex value must be between 0-7.");

        if (dayIndex != value)
          uri = null;

        dayIndex = value;
      }
    }

    public string CountryCode
    {
      get
      {
        return countryCode;
      }

      set
      {
        if (countryCode != value)
          uri = null;

        countryCode = value;
      }
    }

    public string Path
    {
      get
      {
        return path;
      }

      set
      {
        path = value;
      }
    }

    public string File
    {
      get
      {
        return fileName;
      }

      set
      {
        fileName = value;
      }
    }
  }
}
