﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class CountryCodeReplacementToken: TokenBase
  {
    private const string description = "The CountyCodeReplacementToken replaces $countrycode$ with the Bing compatible selected Country code.";
    private const string name = "Country Code Replacement Token";
    private const string trigger = "$countrycode$";

    public override string GetDescription()
    {
      return description;
    }

    public override string GetName()
    {
      return name;
    }

    public override string GetToken()
    {
      return trigger;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(trigger))
      {
        SetTokenState(TokenStates.Processing);
        tokenizedString = tokenizedString.Replace(trigger, BingUtils.CurrentCountryCode);
        Processed = true;
      }

      return tokenizedString;
    }
  }
}
