﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Principal;
using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class CurrentUserWithDomainReplacementToken : ReplacementTokenBase
  {

    #region Private Fields

    private const string token = "$currentuserwithdomain$";
    private const string name = "Current User with Domain Replacement Token";
    private const string description = "The Current User with Domain Replacement Token provides for the current Windows user and domain name.";

    #endregion

    #region Public Methods

    public override string GetName()
    {
      return name;
    }

    public override string GetDescription()
    {
      return description;
    }

    public override string GetToken()
    {
      return token;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        WindowsIdentity id = WindowsIdentity.GetCurrent();
        tokenizedString = tokenizedString.Replace(Token, id.Name);
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion

  }
}
