﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.Utils.ReplacementTokens
{
  public class SecondReplacementToken : FormatStringReplacmentTokenBase
  {

    #region Private Fields

    private string token = "$second$";
    private string name = "Second Replacement Token";
    private string description = "The Second Replacement Token provides for seconds.";

    #endregion

    #region Consturctors

    public SecondReplacementToken(string formatString)
    {
      FormatString = formatString;
    }

    public SecondReplacementToken()
    {

    }

    #endregion

    #region Public Methods

    public override string GetName()
    {
      return name;
    }

    public override string GetDescription()
    {
      return description;
    }

    public override string GetToken()
    {
      return token;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(Token))
      {
        string hourString = string.Format(FormatString, DateTime.Now.Hour);
        tokenizedString = tokenizedString.Replace(Token, hourString);
        Processed = true;
      }

      return tokenizedString;
    }

    #endregion

  }
}
