﻿#region codejockey.net Copyright Banner
/***************************************************************\
 * Copyright 2010 codejockey.net.                                *
 *                                                               *
 * This code is property of codejockey.net and cannot be used    *
 * without explicit permission given by a codejockey.net         *
 * Representative.  For details contact: source@codejockey.net   *
 \***************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using codejockey.Shared.Text.ReplacementTokens;

namespace codejockey.BingPaper.ReplacementTokens
{
  public class BingImageNameReplacementToken : ReplacementTokenBase
  {
    private const string token = "$bingimagename$";
    private const string name = "Bing Image Name Replacement Token";
    private const string description = "The Bing Image Name Replacement Token provides for the current Bing image name.";

    private string imageName;

    public BingImageNameReplacementToken(string bingImageName)
    {
      imageName = bingImageName;
    }

    public override string GetName()
    {
      return name;
    }

    public override string GetDescription()
    {
      return description;
    }

    public override string GetToken()
    {
      return token;
    }

    public override string Replace(string tokenizedString)
    {
      tokenizedString = base.Replace(tokenizedString);

      if (tokenizedString.Contains(token))
      {
        tokenizedString = tokenizedString.Replace(GetToken(), imageName);
        Processed = true;
      }

      return tokenizedString;
    }
  }
}
